package org.insa.graphs.algorithm.shortestpath;

import org.insa.graphs.model.*;
import org.insa.graphs.algorithm.AbstractInputData.Mode;

public class AStarAlgorithm extends DijkstraAlgorithm {

    public AStarAlgorithm(ShortestPathData data) {
        super(data);
    }
    
    protected void InitialiseLabels(Label[] labels, ShortestPathData data) {
    	double MaxSpeed = data.getMaximumSpeed();
    	if (MaxSpeed == -1) {
    		MaxSpeed = data.getGraph().getGraphInformation().getMaximumSpeed();
    	}
    	if (MaxSpeed == -1) {
        	System.out.println("Toujours -1 !!!!");
    	}
    	
        if (data.getMode() == Mode.LENGTH) {
        	MaxSpeed = 1.01;
        } else {
        	MaxSpeed = MaxSpeed / 3.6;
        }
        
        for (Node node: data.getGraph().getNodes()) {
        	double estimation = Point.distance(node.getPoint(), data.getDestination().getPoint())/MaxSpeed;
        	labels[node.getId()] = new LabelStar(node, estimation);
        }
    }
}
