package org.insa.graphs.algorithm.shortestpath;

import org.insa.graphs.model.Node;
import org.insa.graphs.model.Arc;
import java.lang.Comparable;

public class Label implements Comparable<Label>{
	private Node sommetCourant;
	private boolean marque;
	private double cout;
	private Arc pere;
	
	public Label(Node init_Node) {
		this.sommetCourant = init_Node;
		this.marque = false;
		this.cout = Double.POSITIVE_INFINITY;
		this.pere = null;
	}
	
	public Node getSommetCourant() {
		return this.sommetCourant;
	}

	public boolean isMarque() {
		return this.marque;
	}

	public double getCost() {
		return this.cout;
	}
	
	public double getEstimation() {
		return 0;
	}
	
	public double getTotalCost() {
		return this.cout;
	}
	
	public Arc getPere() {
		return this.pere;
	}

	public void actualiser(double cout, Arc pere) {
		this.cout = cout;
		this.pere = pere;
	}
	
	public void marquer() {
		this.marque = true;
	}	
	
	public int compareTo(Label o) {
		double epsilon = 0.0;
		double diff = this.getTotalCost() - o.getTotalCost();
		if (diff < -epsilon) {
			return -1;
		} else if (diff > epsilon) {
			return 1;
		} else {
			diff = this.getEstimation() - o.getEstimation();
			if (diff < -epsilon) {
				return -1;
			} else if (diff > epsilon) {
				return 1;
			} else {
				return 0;
			}
		}
	}
}